<template>
  <div class="firma-bloque" :class="{ 'error-validacion': error }">
    <slot name="delete"></slot>
    <v-autocomplete
      v-model="data.numeroEmpleado"
      :items="usuariosFixed"
      :loading="isLoading"
      :search-input.sync="search"
      item-text="nombre"
      item-value="numeroEmpleado"
      item-disabled="disabled"
      label="Busca el usuario"
      single-line
      :disabled="data.idFirma != null"
      :error="$v.$error"
    >
      <template v-if="$v.$error" v-slot:append-outer>
        <v-popover placement="bottom-end" offset="16">
          <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
          <template slot="popover">
            <div @click="$v.$reset()" v-close-popover>
              <span v-if="!$v.required">¡No te olvides de éste campo!</span>
            </div>
          </template>
        </v-popover>
      </template>
    </v-autocomplete>
  </div>
</template>
<style scoped>
.firma-bloque .v-btn {
  float: right;
  height: 25px;
  right: -1px;
  top: -1px;
  cursor: pointer;
}
.firma-bloque {
  border: dashed 2px grey;
}
.firma-bloque.error-validacion {
  border: dashed 2px rgb(253, 81, 81);
}
</style>
<script>
import store from "@/store";
import { required } from "vuelidate/lib/validators";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Firmador",
  props: ["value", "indice", "srcData", "error"],
  data() {
    return {
      usuarios: [],
      search: null,
      isLoading: false,
    };
  },
  computed: {
    usuariosFixed() {
      let usuariosBack = JSON.parse(JSON.stringify(this.usuarios));
      let numerosEmpleado = [];
      this.srcData.forEach((element) => {
        if (element.numeroEmpleado) {
          if (element.numeroEmpleado == this.value.numeroEmpleado) {
            element.indice = this.indice + 1;
          }
          numerosEmpleado.push(element.numeroEmpleado);
        }
      });
      return usuariosBack.map((itemUsuario) => {
        itemUsuario.nombre =
          itemUsuario.numeroEmpleado + " - " + itemUsuario.nombre;
        itemUsuario.disabled = numerosEmpleado.includes(
          itemUsuario.numeroEmpleado
        );
        return itemUsuario;
      });
    },
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  watch: {
    search(val) {
      if (this.isLoading) return;
      if (val && val.length > 3) {
        this.getUsuarios();
      }
    },
    data: {
      deep: true,
      handler: function(val, prev) {
        if (!val.numeroEmpleado) {
          this.$emit("cleared", prev);
        }
      },
    },
    "$v.data.numeroEmpleado": {
      deep: true,
      handler: function(val, prev) {
        if (!val.$invalid && !this.data.idFirma) {
          this.$emit("valid-input", this.data);
        }
      },
    },
  },
  validations: {
    data: {
      numeroEmpleado: {
        required,
      },
    },
  },
  methods: {
    getUsuarios() {
      this.isLoading = true;
      var self = this;
      let options = {
        usuario: this.search,
      };
      axios
        .post("/usuarios-negocio/v1/busquedas", options)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.usuarios = data.resultado.usuarios;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },
  },
  created() {
    if (this.data.numeroEmpleado) {
      this.search = "" + this.data.numeroEmpleado;
    }
  },
};
</script>
